## qastools 0.23.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED ( VERSION 3.6 )
PROJECT ( QasTools
    VERSION 0.23.0
    LANGUAGES CXX )


# Build type

SET ( CMAKE_BUILD_TYPE "Release" CACHE STRING "CMake build type" )
SET ( BUILD_LIST "qascommon,qasconfig,qashctl,qasmixer" CACHE STRING
      "List of parts to build" )


# program/package/version suffix

SET ( PROGRAM_SUFFIX "" CACHE STRING "Program suffix" )
SET ( VERSION_SUFFIX "" CACHE STRING "Version suffix" )
SET ( PACKAGE_SUFFIX "" CACHE STRING "Package suffix" )


# Package name

SET ( PACKAGE_TITLE "QasTools" CACHE STRING "Package title" )
SET ( PACKAGE_NAME "qastools${PACKAGE_SUFFIX}" CACHE STRING "Package name" )


# Package version

SET ( PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}" )
SET ( PACKAGE_VERSION_MINOR "${PROJECT_VERSION_MINOR}" )
SET ( PACKAGE_VERSION_PATCH "${PROJECT_VERSION_PATCH}" )

SET ( PACKAGE_VERSION
    "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}${VERSION_SUFFIX}" )


# Installation directories

SET ( INSTALL_DIR_BIN "bin" CACHE STRING
      "Installation directory for binaries" )
SET ( INSTALL_DIR_MAN "share/man/man1" CACHE STRING
      "Installation directory for manpages" )
SET ( INSTALL_DIR_APPSTREAM "share/metainfo" CACHE STRING
      "Installation directory for AppStream metadata" )
SET ( INSTALL_DIR_DESKTOP "share/applications" CACHE STRING
      "Installation directory for desktop files" )

SET ( INSTALL_DIR_DATA "share/${PACKAGE_NAME}" CACHE STRING
      "Installation directory for application data" )
SET ( INSTALL_DIR_L10N "${INSTALL_DIR_DATA}/l10n" CACHE STRING
      "Installation directory for localization files" )
SET ( INSTALL_DIR_APP_ICONS "${INSTALL_DIR_DATA}/icons" CACHE STRING
      "Installation directory for application icons" )
SET ( INSTALL_DIR_WIDGETS_GRAPHICS "${INSTALL_DIR_DATA}/widgets" CACHE STRING
      "Installation directory for widget graphics" )


# Icon installation directories

SET ( INSTALL_DIR_ICONS_PNG_16 "share/icons/hicolor/16x16/apps" CACHE STRING
      "Installation directory for application icons (16x16)" )
SET ( INSTALL_DIR_ICONS_PNG_32 "share/icons/hicolor/32x32/apps" CACHE STRING
      "Installation directory for application icons (32x32)" )
SET ( INSTALL_DIR_ICONS_PNG_48 "share/icons/hicolor/48x48/apps" CACHE STRING
      "Installation directory for application icons (48x48)" )
SET ( INSTALL_DIR_ICONS_PNG_64 "share/icons/hicolor/64x64/apps" CACHE STRING
      "Installation directory for application icons (64x64)" )
SET ( INSTALL_DIR_ICONS_SVG "share/icons/hicolor/scalable/apps" CACHE STRING
      "Installation directory for application icons (scalable)" )


# Localization file prefix

SET ( L10N_PREFIX "${PACKAGE_NAME}_" )


# Shared resources

SET ( SHARED_RES_DIR "${CMAKE_CURRENT_SOURCE_DIR}/shared" )
SET ( SHARED_SRC_DIR "${SHARED_RES_DIR}/src" )
SET ( SHARED_INC_DIR "${SHARED_RES_DIR}/src" )


# Installation

IF ( NOT SKIP_LICENSE_INSTALL )
  INSTALL( FILES "COPYING"
    DESTINATION ${INSTALL_DIR_DATA} )
ENDIF ( NOT SKIP_LICENSE_INSTALL )


# Process subdirectories

IF ( ${BUILD_LIST} MATCHES "qascommon" )
  ADD_SUBDIRECTORY ( i18n )
  ADD_SUBDIRECTORY ( shared )
ENDIF ( ${BUILD_LIST} MATCHES "qascommon" )

IF ( ${BUILD_LIST} MATCHES "qasconfig" )
  ADD_SUBDIRECTORY ( qasconfig )
ENDIF ( ${BUILD_LIST} MATCHES "qasconfig" )

IF ( ${BUILD_LIST} MATCHES "qashctl" )
  ADD_SUBDIRECTORY ( qashctl )
ENDIF ( ${BUILD_LIST} MATCHES "qashctl" )

IF ( ${BUILD_LIST} MATCHES "qasmixer" )
  ADD_SUBDIRECTORY ( qasmixer )
ENDIF ( ${BUILD_LIST} MATCHES "qasmixer" )

=== i18n/CMakeLists.txt ===
# Find modules
FIND_PACKAGE ( Qt5LinguistTools )

# Find translations source files
FILE ( GLOB ts_files "ts/*.ts" )

# Setup translations build target
QT5_ADD_TRANSLATION ( qm_files ${ts_files} )
ADD_CUSTOM_TARGET ( translations ALL DEPENDS ${qm_files} )

# Install translations
FOREACH ( qm_src ${qm_files} )
  STRING( REGEX REPLACE ".*app_" "${L10N_PREFIX}" qm_name ${qm_src} )
  INSTALL( FILES ${qm_src}
    RENAME ${qm_name}
    DESTINATION ${INSTALL_DIR_L10N} )
ENDFOREACH ( qm_src )

=== qashctl/CMakeLists.txt ===
# Program name

SET ( PROGRAM_TITLE "QasHctl" )
SET ( PROGRAM_NAME "qashctl${PROGRAM_SUFFIX}" )
string ( TOUPPER ${PROGRAM_NAME} PROGRAM_NAME_UCASE )


# Program version

SET ( VERSION_MAJOR ${PACKAGE_VERSION_MAJOR} )
SET ( VERSION_MINOR ${PACKAGE_VERSION_MINOR} )
SET ( VERSION_PATCH ${PACKAGE_VERSION_PATCH} )

SET ( VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX}" )


# Process subdirectories

ADD_SUBDIRECTORY ( src )
ADD_SUBDIRECTORY ( graphics )
ADD_SUBDIRECTORY ( share )

=== shared/CMakeLists.txt ===
# Process subdirectories

ADD_SUBDIRECTORY ( graphics )

=== qasconfig/graphics/CMakeLists.txt ===
# Install application icons

INSTALL( FILES icons/app-icon-16x16.png
  DESTINATION ${INSTALL_DIR_ICONS_PNG_16}
  RENAME ${PROGRAM_NAME}.png )

INSTALL( FILES icons/app-icon-32x32.png
  DESTINATION ${INSTALL_DIR_ICONS_PNG_32}
  RENAME ${PROGRAM_NAME}.png )

INSTALL( FILES icons/app-icon-48x48.png
  DESTINATION ${INSTALL_DIR_ICONS_PNG_48}
  RENAME ${PROGRAM_NAME}.png )

INSTALL( FILES icons/app-icon-64x64.png
  DESTINATION ${INSTALL_DIR_ICONS_PNG_64}
  RENAME ${PROGRAM_NAME}.png )

INSTALL( FILES icons/app-icon.svg
  DESTINATION ${INSTALL_DIR_ICONS_SVG}
  RENAME ${PROGRAM_NAME}.svg )

=== qasconfig/src/CMakeLists.txt ===
# --- Find modules

FIND_PACKAGE (
  Qt5
  COMPONENTS
    Widgets
  REQUIRED )
FIND_PACKAGE ( ALSA REQUIRED )


# --- Configure files

INCLUDE ( CheckIncludeFiles )

CONFIGURE_FILE (
  ${SHARED_SRC_DIR}/qastools_config.hpp.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/qastools_config.hpp )


# --- Sources

SET ( SRC_GUI
  ${SHARED_SRC_DIR}/qsnd/alsa.cpp
  ${SHARED_SRC_DIR}/qsnd/alsa_config_watcher.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_vertical.cpp
  ${SHARED_SRC_DIR}/wdg/text_browser.cpp
  ${SHARED_SRC_DIR}/wdg/tree_view_kv.cpp
  ${SHARED_SRC_DIR}/views/view_utility.cpp
  ${SHARED_SRC_DIR}/views/basic_dialog.cpp
  ${SHARED_SRC_DIR}/views/multi_page_dialog.cpp
  ${SHARED_SRC_DIR}/views/info_dialog.cpp
  ${SHARED_SRC_DIR}/license_texts.cpp

  qsnd/alsa_config_model.cpp
  views/alsa_config_view.cpp

  info_texts.cpp
  static_tree.cpp
  static_tree_model.cpp
  main_window.cpp
  desktop_items.cpp
  main.cpp
)


# --- Compiler flags

SET ( CMAKE_CXX_STANDARD 17 )
SET ( CMAKE_CXX_STANDARD_REQUIRED OFF )
SET ( CMAKE_CXX_EXTENSIONS OFF )
SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Wunused -Wall" )
SET ( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -fno-inline" )
SET ( CMAKE_CXX_FLAGS_RELEASE "-O2 ${CMAKE_CXX_FLAGS_RELEASE}" )


# --- Include directories

INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR} )
INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_BINARY_DIR} )
INCLUDE_DIRECTORIES ( ${SHARED_INC_DIR} )
INCLUDE_DIRECTORIES ( ${ALSA_INCLUDE_DIRS} )


# --- Executable

ADD_EXECUTABLE ( ${PROGRAM_NAME}
  ${SRC_GUI}
  ${SRC_GUI_MOC}
)
SET_TARGET_PROPERTIES ( ${PROGRAM_NAME} PROPERTIES AUTOMOC ON )
TARGET_LINK_LIBRARIES ( ${PROGRAM_NAME}
  Qt5::Widgets
  ${ALSA_LIBRARIES}
)


# --- Installation

INSTALL (
  TARGETS ${PROGRAM_NAME} RUNTIME
  DESTINATION ${INSTALL_DIR_BIN} )

=== qashctl/src/CMakeLists.txt ===
# --- Find modules

FIND_PACKAGE (
  Qt5
  COMPONENTS
    Widgets
    Svg
  REQUIRED )
FIND_PACKAGE ( ALSA REQUIRED )

# TODO: FIND_PACKAGE
SET ( UDEV_LIBRARIES udev )


# --- Configure files

INCLUDE ( CheckIncludeFiles )
CONFIGURE_FILE (
  ${SHARED_SRC_DIR}/qastools_config.hpp.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/qastools_config.hpp )


# --- Sources

SET ( SRC_GUI
  ${SHARED_SRC_DIR}/qsnd/alsa.cpp
  ${SHARED_SRC_DIR}/qsnd/alsa_config_watcher.cpp
  ${SHARED_SRC_DIR}/qsnd/event_types.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_address_argument.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_address.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_format_argument.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_format.cpp
  ${SHARED_SRC_DIR}/qsnd/card_info.cpp
  ${SHARED_SRC_DIR}/qsnd/cards_model.cpp
  ${SHARED_SRC_DIR}/qsnd/controls_database.cpp
  ${SHARED_SRC_DIR}/qsnd/controls_model.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer_hctl.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer_hctl_elem.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer_hctl_elem_group.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer_hctl_info_db.cpp
  ${SHARED_SRC_DIR}/qsnd/udev_device_lookout.cpp

  ${SHARED_SRC_DIR}/dpe/image_allocator.cpp
  ${SHARED_SRC_DIR}/dpe/image.cpp
  ${SHARED_SRC_DIR}/dpe/image_request.cpp
  ${SHARED_SRC_DIR}/dpe/image_set.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_group.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_meta.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_state.cpp
  ${SHARED_SRC_DIR}/dpe/is_buffer.cpp
  ${SHARED_SRC_DIR}/dpe/is_buffer_handle.cpp
  ${SHARED_SRC_DIR}/dpe/painter.cpp
  ${SHARED_SRC_DIR}/dpe/painter_simple.cpp
  ${SHARED_SRC_DIR}/dpe/painter_thread.cpp
  ${SHARED_SRC_DIR}/dpe/painter_thread_shared.cpp
  ${SHARED_SRC_DIR}/dpe/paint_job.cpp

  ${SHARED_SRC_DIR}/wdg/label_width.cpp
  ${SHARED_SRC_DIR}/wdg/label_elide.cpp
  ${SHARED_SRC_DIR}/wdg/tree_view_kv.cpp
  ${SHARED_SRC_DIR}/wdg/text_browser.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_horizontal.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_vertical.cpp
  ${SHARED_SRC_DIR}/wdg/color_methods.cpp
  ${SHARED_SRC_DIR}/wdg/cubic_curve.cpp
  ${SHARED_SRC_DIR}/wdg/uint_mapper.cpp
  ${SHARED_SRC_DIR}/wdg/ds_widget_painter.cpp
  ${SHARED_SRC_DIR}/wdg/ds_widget_style_db.cpp
  ${SHARED_SRC_DIR}/wdg/ds_imaging.cpp
  ${SHARED_SRC_DIR}/wdg/ds_switch.cpp
  ${SHARED_SRC_DIR}/wdg/ds_switch_painter_circle.cpp
  ${SHARED_SRC_DIR}/wdg/ds_switch_painter_svg.cpp
  ${SHARED_SRC_DIR}/wdg/ds_slider.cpp
  ${SHARED_SRC_DIR}/wdg/ds_slider_meta_bg.cpp
  ${SHARED_SRC_DIR}/wdg/ds_slider_painter_bevelled.cpp
  ${SHARED_SRC_DIR}/wdg/event_types.cpp
  ${SHARED_SRC_DIR}/wdg/pass_events.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxies_column.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxies_group.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy_enum.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy_slider.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy_style.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy_switch.cpp
  ${SHARED_SRC_DIR}/wdg/pad_focus_info.cpp
  ${SHARED_SRC_DIR}/wdg/layout_weights.cpp
  ${SHARED_SRC_DIR}/wdg/equal_columns_layout_group.cpp
  ${SHARED_SRC_DIR}/wdg/equal_columns_layout.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_data.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_footer.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_header.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_header_data.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_layout.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_style.cpp

  ${SHARED_SRC_DIR}/mwdg/event_types.cpp
  ${SHARED_SRC_DIR}/mwdg/slider_status_widget.cpp
  ${SHARED_SRC_DIR}/mwdg/controls_view.cpp
  ${SHARED_SRC_DIR}/mwdg/controls_delegate.cpp
  ${SHARED_SRC_DIR}/mwdg/ctl_arg_view.cpp
  ${SHARED_SRC_DIR}/mwdg/ctl_arg_view_integer.cpp
  ${SHARED_SRC_DIR}/mwdg/ctl_arg_view_string.cpp
  ${SHARED_SRC_DIR}/mwdg/ctl_arg_view_card.cpp
  ${SHARED_SRC_DIR}/mwdg/inputs_setup.cpp
  ${SHARED_SRC_DIR}/mwdg/mixer_device_setup.cpp
  ${SHARED_SRC_DIR}/mwdg/mixer_style.cpp

  ${SHARED_SRC_DIR}/views/view_utility.cpp
  ${SHARED_SRC_DIR}/views/message_widget.cpp
  ${SHARED_SRC_DIR}/views/view_base_setup.cpp
  ${SHARED_SRC_DIR}/views/view_base.cpp
  ${SHARED_SRC_DIR}/views/device_selection_view_setup.cpp
  ${SHARED_SRC_DIR}/views/device_selection_view.cpp
  ${SHARED_SRC_DIR}/views/basic_dialog.cpp
  ${SHARED_SRC_DIR}/views/multi_page_dialog.cpp
  ${SHARED_SRC_DIR}/views/info_dialog.cpp

  ${SHARED_SRC_DIR}/license_texts.cpp

  mwdg/mixer_hctl.cpp
  mwdg/mixer_hctl_edit_bool.cpp
  mwdg/mixer_hctl_edit_enum.cpp
  mwdg/mixer_hctl_edit_int.cpp
  mwdg/mixer_hctl_editor.cpp
  mwdg/mixer_hctl_editor_data.cpp
  mwdg/mixer_hctl_edit_unsupported.cpp
  mwdg/mixer_hctl_int_proxies_group.cpp
  mwdg/mixer_hctl_int_proxy_column.cpp
  mwdg/mixer_hctl_int_proxy_slider.cpp
  mwdg/mixer_hctl_proxies_group.cpp
  mwdg/mixer_hctl_proxy.cpp
  mwdg/mixer_hctl_proxy_enum.cpp
  mwdg/mixer_hctl_proxy_switch.cpp
  mwdg/mixer_hctl_slider_status_widget.cpp
  mwdg/mixer_hctl_table_model.cpp
  mwdg/mixer_hctl_tree_model.cpp

  views/mixer_hctl_setup.cpp
  views/mixer_hctl.cpp

  info_texts.cpp
  main_window_setup.cpp
  main_window.cpp
  desktop_items.cpp
  main.cpp
)


# --- Compiler flags

SET ( CMAKE_CXX_STANDARD 17 )
SET ( CMAKE_CXX_STANDARD_REQUIRED OFF )
SET ( CMAKE_CXX_EXTENSIONS OFF )
SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Wunused -Wall" )
SET ( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -fno-inline" )
SET ( CMAKE_CXX_FLAGS_RELEASE "-O2 ${CMAKE_CXX_FLAGS_RELEASE}" )


# --- Include directories

INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR} )
INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_BINARY_DIR} )
INCLUDE_DIRECTORIES ( ${SHARED_INC_DIR} )
INCLUDE_DIRECTORIES ( ${ALSA_INCLUDE_DIRS} )


# --- Executable

ADD_EXECUTABLE ( ${PROGRAM_NAME}
  ${SRC_GUI}
  ${SRC_GUI_MOC}
)
SET_TARGET_PROPERTIES ( ${PROGRAM_NAME} PROPERTIES AUTOMOC ON )
TARGET_LINK_LIBRARIES ( ${PROGRAM_NAME}
  Qt5::Widgets
  Qt5::Svg
  ${ALSA_LIBRARIES}
  ${UDEV_LIBRARIES}
)


# --- Installation

INSTALL (
  TARGETS ${PROGRAM_NAME} RUNTIME
  DESTINATION ${INSTALL_DIR_BIN} )

=== qasmixer/graphics/CMakeLists.txt ===
# Install application icons

INSTALL( FILES icons/app-icon-16x16.png
  DESTINATION ${INSTALL_DIR_ICONS_PNG_16}
  RENAME ${PROGRAM_NAME}.png )

INSTALL( FILES icons/app-icon-32x32.png
  DESTINATION ${INSTALL_DIR_ICONS_PNG_32}
  RENAME ${PROGRAM_NAME}.png )

INSTALL( FILES icons/app-icon-48x48.png
  DESTINATION ${INSTALL_DIR_ICONS_PNG_48}
  RENAME ${PROGRAM_NAME}.png )

INSTALL( FILES icons/app-icon-64x64.png
  DESTINATION ${INSTALL_DIR_ICONS_PNG_64}
  RENAME ${PROGRAM_NAME}.png )

INSTALL( FILES icons/app-icon.svg
  DESTINATION ${INSTALL_DIR_ICONS_SVG}
  RENAME ${PROGRAM_NAME}.svg )


# Install simple mixer icons

INSTALL ( FILES icons/show-playback.svg
  DESTINATION ${INSTALL_DIR_APP_ICONS} )

INSTALL ( FILES icons/show-capture.svg
  DESTINATION ${INSTALL_DIR_APP_ICONS} )

=== qasmixer/src/CMakeLists.txt ===
# --- Find modules

FIND_PACKAGE (
  Qt5
  COMPONENTS
    Core
    Widgets
    Svg
    Network
  REQUIRED )
FIND_PACKAGE ( ALSA REQUIRED )

# TODO: FIND_PACKAGE
SET ( UDEV_LIBRARIES udev )


# --- Configure files

INCLUDE ( CheckIncludeFiles )
CONFIGURE_FILE (
  ${SHARED_SRC_DIR}/qastools_config.hpp.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/qastools_config.hpp )


# --- Sources

SET ( SRC_GUI
  ${SHARED_SRC_DIR}/qsnd/alsa.cpp
  ${SHARED_SRC_DIR}/qsnd/event_types.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_format_argument.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_format.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_address_argument.cpp
  ${SHARED_SRC_DIR}/qsnd/ctl_address.cpp
  ${SHARED_SRC_DIR}/qsnd/controls_database.cpp
  ${SHARED_SRC_DIR}/qsnd/controls_model.cpp
  ${SHARED_SRC_DIR}/qsnd/cards_model.cpp
  ${SHARED_SRC_DIR}/qsnd/card_info.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer_simple_elem.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer_simple_filter.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer_simple_filter_name.cpp
  ${SHARED_SRC_DIR}/qsnd/mixer_simple.cpp
  ${SHARED_SRC_DIR}/qsnd/udev_device_lookout.cpp

  ${SHARED_SRC_DIR}/dpe/image.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_meta.cpp
  ${SHARED_SRC_DIR}/dpe/image_set.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_group.cpp
  ${SHARED_SRC_DIR}/dpe/image_set_state.cpp
  ${SHARED_SRC_DIR}/dpe/image_request.cpp
  ${SHARED_SRC_DIR}/dpe/image_allocator.cpp
  ${SHARED_SRC_DIR}/dpe/is_buffer_handle.cpp
  ${SHARED_SRC_DIR}/dpe/is_buffer.cpp
  ${SHARED_SRC_DIR}/dpe/paint_job.cpp
  ${SHARED_SRC_DIR}/dpe/painter.cpp
  ${SHARED_SRC_DIR}/dpe/painter_simple.cpp
  ${SHARED_SRC_DIR}/dpe/painter_thread.cpp
  ${SHARED_SRC_DIR}/dpe/painter_thread_shared.cpp

  ${SHARED_SRC_DIR}/wdg/label_elide.cpp
  ${SHARED_SRC_DIR}/wdg/label_width.cpp
  ${SHARED_SRC_DIR}/wdg/text_browser.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_horizontal.cpp
  ${SHARED_SRC_DIR}/wdg/scroll_area_vertical.cpp
  ${SHARED_SRC_DIR}/wdg/balloon_widget.cpp
  ${SHARED_SRC_DIR}/wdg/color_methods.cpp
  ${SHARED_SRC_DIR}/wdg/ds_widget_style_db.cpp
  ${SHARED_SRC_DIR}/wdg/ds_widget_painter.cpp
  ${SHARED_SRC_DIR}/wdg/ds_imaging.cpp
  ${SHARED_SRC_DIR}/wdg/ds_switch_painter_circle.cpp
  ${SHARED_SRC_DIR}/wdg/ds_switch_painter_close.cpp
  ${SHARED_SRC_DIR}/wdg/ds_switch_painter_svg.cpp
  ${SHARED_SRC_DIR}/wdg/ds_switch.cpp

  ${SHARED_SRC_DIR}/wdg/uint_mapper.cpp
  ${SHARED_SRC_DIR}/wdg/cubic_curve.cpp
  ${SHARED_SRC_DIR}/wdg/ds_slider_meta_bg.cpp
  ${SHARED_SRC_DIR}/wdg/ds_slider_painter_bevelled.cpp
  ${SHARED_SRC_DIR}/wdg/ds_slider.cpp

  ${SHARED_SRC_DIR}/wdg/event_types.cpp
  ${SHARED_SRC_DIR}/wdg/pass_events.cpp

  ${SHARED_SRC_DIR}/wdg/pad_focus_info.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy_style.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy_slider.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy_switch.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxy_enum.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxies_column.cpp
  ${SHARED_SRC_DIR}/wdg/pad_proxies_group.cpp

  ${SHARED_SRC_DIR}/wdg/layout_weights.cpp
  ${SHARED_SRC_DIR}/wdg/equal_columns_layout_group.cpp
  ${SHARED_SRC_DIR}/wdg/equal_columns_layout.cpp
  ${SHARED_SRC_DIR}/wdg/fill_columns_layout.cpp

  ${SHARED_SRC_DIR}/wdg/sliders_pad_layout.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_style.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_data.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_header_data.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_header.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad_footer.cpp
  ${SHARED_SRC_DIR}/wdg/sliders_pad.cpp

  ${SHARED_SRC_DIR}/wdg/switches_pad_widgets.cpp
  ${SHARED_SRC_DIR}/wdg/switches_pad_widgets_group.cpp
  ${SHARED_SRC_DIR}/wdg/switches_pad.cpp
  ${SHARED_SRC_DIR}/wdg/switches_area.cpp

  ${SHARED_SRC_DIR}/mwdg/event_types.cpp
  ${SHARED_SRC_DIR}/mwdg/ctl_arg_view.cpp
  ${SHARED_SRC_DIR}/mwdg/ctl_arg_view_string.cpp
  ${SHARED_SRC_DIR}/mwdg/ctl_arg_view_integer.cpp
  ${SHARED_SRC_DIR}/mwdg/ctl_arg_view_card.cpp
  ${SHARED_SRC_DIR}/mwdg/controls_delegate.cpp
  ${SHARED_SRC_DIR}/mwdg/controls_view.cpp
  ${SHARED_SRC_DIR}/mwdg/slider_status_widget.cpp
  ${SHARED_SRC_DIR}/mwdg/inputs_setup.cpp
  ${SHARED_SRC_DIR}/mwdg/mixer_device_setup.cpp
  ${SHARED_SRC_DIR}/mwdg/mixer_style.cpp

  ${SHARED_SRC_DIR}/views/view_utility.cpp
  ${SHARED_SRC_DIR}/views/message_widget.cpp
  ${SHARED_SRC_DIR}/views/view_base_setup.cpp
  ${SHARED_SRC_DIR}/views/view_base.cpp
  ${SHARED_SRC_DIR}/views/device_selection_view_setup.cpp
  ${SHARED_SRC_DIR}/views/device_selection_view.cpp
  ${SHARED_SRC_DIR}/views/basic_dialog.cpp
  ${SHARED_SRC_DIR}/views/multi_page_dialog.cpp
  ${SHARED_SRC_DIR}/views/info_dialog.cpp

  ${SHARED_SRC_DIR}/unix_signal_handler.cpp
  ${SHARED_SRC_DIR}/single_application.cpp
  ${SHARED_SRC_DIR}/license_texts.cpp

  mwdg/mixer_gui_state.cpp
  mwdg/mixer_simple_setup.cpp
  mwdg/mixer_separation_info.cpp
  mwdg/mixer_sliders_proxy_slider.cpp
  mwdg/mixer_sliders_proxy_switch.cpp
  mwdg/mixer_sliders_proxies_column.cpp
  mwdg/mixer_sliders_proxies_group.cpp
  mwdg/mixer_sliders_status_widget.cpp
  mwdg/mixer_sliders.cpp
  mwdg/mixer_switches_proxy_enum.cpp
  mwdg/mixer_switches_proxy_switch.cpp
  mwdg/mixer_switches_proxies_group.cpp
  mwdg/mixer_switches.cpp

  views/mixer_simple_setup.cpp
  views/mixer_simple.cpp
  views/settings_dialog_setup.cpp
  views/settings_dialog.cpp

  tray_mixer_mdev_setup.cpp
  tray_mixer_view_setup.cpp
  tray_mixer_icon.cpp
  tray_mixer_balloon.cpp
  tray_mixer.cpp
  cmd_options.cpp
  main_window_setup.cpp
  main_window.cpp
  desktop_items_setup.cpp
  desktop_items.cpp

  init_globals.cpp
  info_texts.cpp
  main.cpp
)


# --- Compiler flags

SET ( CMAKE_CXX_STANDARD 17 )
SET ( CMAKE_CXX_STANDARD_REQUIRED OFF )
SET ( CMAKE_CXX_EXTENSIONS OFF )
SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Wunused -Wall" )
SET ( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g -fno-inline" )
SET ( CMAKE_CXX_FLAGS_RELEASE "-O2 ${CMAKE_CXX_FLAGS_RELEASE}" )


# --- Include directories

INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_SOURCE_DIR} )
INCLUDE_DIRECTORIES ( ${CMAKE_CURRENT_BINARY_DIR} )
INCLUDE_DIRECTORIES ( ${SHARED_INC_DIR} )
INCLUDE_DIRECTORIES ( ${ALSA_INCLUDE_DIRS} )


# --- Executable

ADD_EXECUTABLE ( ${PROGRAM_NAME}
  ${SRC_GUI}
)
SET_TARGET_PROPERTIES ( ${PROGRAM_NAME} PROPERTIES AUTOMOC ON )
TARGET_LINK_LIBRARIES ( ${PROGRAM_NAME}
  Qt5::Widgets
  Qt5::Svg
  Qt5::Network
  ${ALSA_LIBRARIES}
  ${UDEV_LIBRARIES}
)


# --- Installation

INSTALL (
  TARGETS ${PROGRAM_NAME} RUNTIME
  DESTINATION ${INSTALL_DIR_BIN} )

=== qasconfig/share/man/CMakeLists.txt ===
# Find gzip
FIND_PACKAGE ( UnixCommands REQUIRED )

IF ( NOT GZIP )
  MESSAGE ( FATAL_ERROR "Unable to find 'gzip' program" )
ENDIF ( NOT GZIP )


# Configure manpages

SET ( man_src  ${CMAKE_CURRENT_SOURCE_DIR}/manpage.1.cmake )
SET ( man_plain ${CMAKE_CURRENT_BINARY_DIR}/manpage.1 )
SET ( man_gz ${CMAKE_CURRENT_BINARY_DIR}/manpage.1.gz )

CONFIGURE_FILE ( ${man_src} ${man_plain} )


# Compress manpages

ADD_CUSTOM_COMMAND (
  OUTPUT ${man_gz}
  COMMAND ${GZIP} -c -9 ${man_plain} > ${man_gz}
  DEPENDS ${man_plain}
  COMMENT "Building ${man_gz}" )

ADD_CUSTOM_TARGET (
  qasconfig_manpage ALL
  DEPENDS ${man_gz} )


# Installation of the manpage

INSTALL ( FILES ${man_gz}
  DESTINATION ${INSTALL_DIR_MAN}
  RENAME ${PROGRAM_NAME}.1.gz )

=== qashctl/share/man/CMakeLists.txt ===
# Find gzip
FIND_PACKAGE ( UnixCommands REQUIRED )

IF ( NOT GZIP )
  MESSAGE ( FATAL_ERROR "Unable to find 'gzip' program" )
ENDIF ( NOT GZIP )


# Configure manpages

SET ( man_src  ${CMAKE_CURRENT_SOURCE_DIR}/manpage.1.cmake )
SET ( man_plain ${CMAKE_CURRENT_BINARY_DIR}/manpage.1 )
SET ( man_gz ${CMAKE_CURRENT_BINARY_DIR}/manpage.1.gz )

CONFIGURE_FILE ( ${man_src} ${man_plain} )


# Compress manpages

ADD_CUSTOM_COMMAND (
  OUTPUT ${man_gz}
  COMMAND ${GZIP} -c -9 ${man_plain} > ${man_gz}
  DEPENDS ${man_plain}
  COMMENT "Building ${man_gz}" )

ADD_CUSTOM_TARGET (
  qashctl_manpage ALL
  DEPENDS ${man_gz} )


# Installation of the manpage

INSTALL ( FILES ${man_gz}
  DESTINATION ${INSTALL_DIR_MAN}
  RENAME ${PROGRAM_NAME}.1.gz )

=== qasmixer/share/man/CMakeLists.txt ===
# Find gzip
FIND_PACKAGE ( UnixCommands REQUIRED )

IF ( NOT GZIP )
  MESSAGE ( FATAL_ERROR "Unable to find 'gzip' program" )
ENDIF ( NOT GZIP )


# Configure manpages

SET ( man_src  ${CMAKE_CURRENT_SOURCE_DIR}/manpage.1.cmake )
SET ( man_plain ${CMAKE_CURRENT_BINARY_DIR}/manpage.1 )
SET ( man_gz ${CMAKE_CURRENT_BINARY_DIR}/manpage.1.gz )

CONFIGURE_FILE ( ${man_src} ${man_plain} )


# Compress manpages

ADD_CUSTOM_COMMAND (
  OUTPUT ${man_gz}
  COMMAND ${GZIP} -c -9 ${man_plain} > ${man_gz}
  DEPENDS ${man_plain}
  COMMENT "Building ${man_gz}" )

ADD_CUSTOM_TARGET (
  qasmixer_manpage ALL
  DEPENDS ${man_gz} )


# Installation of the manpage

INSTALL ( FILES ${man_gz}
  DESTINATION ${INSTALL_DIR_MAN}
  RENAME ${PROGRAM_NAME}.1.gz )

=== debian/changelog ===
qastools (0.23.0-1) unstable; urgency=medium

  * New upstream release.
    - Apps: Add AppStream .appdata.xml meta information files
    - Code: Modernize CTL_Address and CTL_Format
    - Code: Make Controls_Model QAbstractListModel based
    - Code: Make Cards_Model QAbstractListModel based
    - Code: Fix missing includes (QPainterPath)
    - Code: Fix compiler warnings (QStyleOptionViewItemV4, fall through)
    - Code: Use clang-format for source code formatting
    - Remove non functional Makefile
    - CMake: Modernize CMakeLists.txt
  * debian/control:
    - Standards-Version raised to 4.5.0
  * debian/copyright:
    - Update dates from 2019 to 2020
  * debian/patches:
    - Remove Makefile removing patch. Makefile was removed by upstream.

 -- Sebastian Holtermann <sebholt@web.de>  Thu, 18 Jun 2020 19:48:12 +0200

=== debian/control ===
Source: qastools
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Sebastian Holtermann <sebholt@web.de>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 libasound2-dev,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 libqt5svg5-dev,
 libudev-dev,
 scour,
 python3-gi-cairo,
 gir1.2-rsvg-2.0
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/sebholt/qastools
Vcs-Git: https://salsa.debian.org/multimedia-team/qastools.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/qastools

Package: qastools-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Description: QasTools common files
 QasTools is a collection of desktop applications for the
 Linux sound system ALSA.
 .
 The applications included are:
  - QasConfig - browser for the ALSA configuration tree
  - QasHctl - mixer for ALSA's High level Control Interface
  - QasMixer - desktop mixer with features similar to alsamixer
 .
 This package contains common files shared by all applications.

Package: qasconfig
Architecture: linux-any
Depends:
 qastools-common,
 ${misc:Depends},
 ${shlibs:Depends}
Description: ALSA configuration browser
 QasTools is a collection of desktop applications for the
 Linux sound system ALSA.
 .
 The applications included are:
  - QasConfig - browser for the ALSA configuration tree
  - QasHctl - mixer for ALSA's High level Control Interface
  - QasMixer - desktop mixer with features similar to alsamixer
 .
 ALSA's configuration resides in a tree structure which gets built
 from the contents of the files /etc/asound.conf and ~/.asoundrc.
 QasConfig is a simple browser for this configuration tree and can
 help to analyze and debug an ALSA setup.

Package: qashctl
Architecture: linux-any
Depends:
 qastools-common,
 ${misc:Depends},
 ${shlibs:Depends}
Description: mixer for ALSA's High level Control Interface
 QasTools is a collection of desktop applications for the
 Linux sound system ALSA.
 .
 The applications included are:
  - QasConfig - browser for the ALSA configuration tree
  - QasHctl - mixer for ALSA's High level Control Interface
  - QasMixer - desktop mixer with features similar to alsamixer
 .
 QasHctl is a mixer application for ALSA's
 "High level Control Interface". This interface allows more complex
 interaction than the "Simple Mixer Interface" which is used by
 alsamixer and QasMixer.

Package: qasmixer
Architecture: linux-any
Depends:
 qastools-common,
 ${misc:Depends},
 ${shlibs:Depends}
Description: ALSA mixer for the desktop
 QasTools is a collection of desktop applications for the
 Linux sound system ALSA.
 .
 The applications included are:
  - QasConfig - browser for the ALSA configuration tree
  - QasHctl - mixer for ALSA's High level Control Interface
  - QasMixer - desktop mixer with features similar to alsamixer
 .
 QasMixer is a desktop mixer application for ALSA's
 "Simple Mixer Interface" and offers features similar to alsamixer.
 It also features a system tray icon with basic mixer functionality.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with scour

override_dh_auto_configure:
	dh_auto_configure -- -DSKIP_LICENSE_INSTALL=TRUE

=== debian/watch ===
version=4
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=gitlab_releases/sebholt/qastools \
    .*/qastools-v?(\d\S+)\.tar\.gz
